//Prototype program for the testing of the DUO device

//find more information about the project: www.polifactory.polimi.it/en/polifactory/delice

//modules used: PIR and Sonar

const int trigpin= 9;
const int echopin= 10;
const int datapin=7;

long distanza;  //distanza percorsa dal segnale sonar
int durata;     //tempo percorso dal segnale sonar
int PIR = LOW;  // stato del PIR
int i =0;


void setup() {            //inizializzo l'uso dei pin e del led integrato su arduino nano
  pinMode (trigpin, OUTPUT);
  pinMode (echopin, INPUT);
  pinMode (datapin, INPUT);
  pinMode(LED_BUILTIN, OUTPUT);
  Serial.begin(9600); 
  
   digitalWrite(trigpin, LOW);  // puisco il valore trigpin
   digitalWrite(LED_BUILTIN, LOW);  //lascio il pin basso per riconoscere l'inizio della sequenza di avvio
      delay(1000);

      
    //sequenza di controllo corretto funzionamento di avvio
  for(i=0; i<4; i++){  
  digitalWrite(LED_BUILTIN, HIGH);   
  delay(100);                      
  digitalWrite(LED_BUILTIN, LOW);    
  delay(500);     
  }
}

void loop(){
  
  PIR = digitalRead(datapin);   // leggo se il sensore PIR ha individuato un movimento


  if(PIR==HIGH){
    delayMicroseconds(2);
// setto il trigpin a valore logico alto per dieci microsecondi. azione necessaria per l'invio dell'impulso del sonar
digitalWrite(trigpin, HIGH);
delayMicroseconds(10);
digitalWrite(trigpin, LOW);
// leggo echopin per il calcolo del tempo passato dall'invio dell'impulso 
durata = pulseIn(echopin, HIGH);
// calcolo la distanza in centimetri
distanza= durata*0.034/2;

//esegui funzione 'if' se il PIR individua un movimento e inoltre il sonar rileva ostacoli a meno di un metro e mezzo di distanza
  if(distanza<150){
    for(i=0; i<5;i++){
          digitalWrite(LED_BUILTIN,HIGH);
          delay(50);
          digitalWrite(LED_BUILTIN,LOW);
          delay(50);
    }
  }
  // esegui 'else' se il PIR individua un movimento ma il sonar non rileva ostacoli entro il metro e mezzo
      else {
        digitalWrite(LED_BUILTIN,HIGH);
        delay(500);
        digitalWrite(LED_BUILTIN,LOW);
          }

  } 
}
